// LogoDialog.cpp : implementation file
//

#include "stdafx.h"
#include "type.h"
#include "LogoDialog.h"
#include "myLogo.h"
#include "myLogoSpin.h"

#include <vector>
#include <algorithm>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

using namespace std;

int index=0;

extern currentLogo;

CString fontFileName;
CString fontDisplayName;

extern vector <CmyLogo*> CmyLogoList;


/////////////////////////////////////////////////////////////////////////////
// LogoDialog dialog


LogoDialog::LogoDialog(CWnd* pParent /*=NULL*/)
	: CDialog(LogoDialog::IDD, pParent)
{
	
	//{{AFX_DATA_INIT(LogoDialog)
	//}}AFX_DATA_INIT

}


void LogoDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(LogoDialog)
	DDX_Control(pDX, IDC_RADIO1, m_radioSource);
	DDX_Control(pDX, IDC_SLIDER2, m_scale);
	DDX_Control(pDX, IDC_SLIDER_RED2, m_redFill);
	DDX_Control(pDX, IDC_SLIDER_OUTLINEWIDTH2, m_OutlineWidth);
	DDX_Control(pDX, IDC_SLIDER_GREEN2, m_greenFill);
	DDX_Control(pDX, IDC_SLIDER_BLUE2, m_blueFill);
	DDX_Control(pDX, IDC_SLIDER_ALPHA2, m_alphaFill);
	DDX_Control(pDX, IDC_SLIDER_HEIGHT, m_height);
	DDX_Control(pDX, IDC_SLIDER_ALPHA, m_alpha);
	DDX_Control(pDX, IDC_SLIDER_RED, m_red);
	DDX_Control(pDX, IDC_SLIDER_GREEN, m_green);
	DDX_Control(pDX, IDC_SLIDER_BLUE, m_blue);
	DDX_Control(pDX, IDC_EDIT1, m_editbox);
	DDX_Control(pDX, IDC_LIST1, m_listBox);
	DDX_Text(pDX, IDC_EDIT1, m_editString);
	DDX_LBString(pDX, IDC_LIST1, m_fontFullName);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(LogoDialog, CDialog)
	//{{AFX_MSG_MAP(LogoDialog)
	ON_LBN_SELCHANGE(IDC_LIST1, OnSelchangeList1)
	ON_EN_CHANGE(IDC_EDIT1, OnChangeEdit1)
	ON_BN_CLICKED(IDC_CONTROL1, OnControl1)
	ON_BN_CLICKED(IDC_RADIO1, OnRadio1)
	ON_BN_CLICKED(IDC_RADIO2, OnRadio2)
	ON_BN_CLICKED(IDC_RADIO4, OnRadio4)
	ON_BN_CLICKED(IDC_RADIO6, OnRadio5)
	ON_BN_CLICKED(IDC_RADIO7, OnRadio6)
	ON_BN_CLICKED(IDC_RADIO8, OnRadio7)
	ON_BN_CLICKED(IDC_RADIO9, OnRadio8)
	ON_BN_CLICKED(IDC_RADIO10, OnRadio9)
	ON_BN_CLICKED(IDC_RADIO5, OnRadio4)
	ON_BN_CLICKED(IDC_RADIO11, OnRadio10)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// LogoDialog message handlers



void LogoDialog::OnSelchangeList1() 
{
	// TODO: Add your control notification handler code here

	CString tester;	
	
	//index= m_listBox.GetCurSel();
	CmyLogoList[currentLogo]->ListIndex = m_listBox.GetCurSel(); 
	
	m_listBox.GetText(CmyLogoList[currentLogo]->ListIndex,tester);

	GetFontFile(tester,fontDisplayName,fontFileName);
	
	
	
}

void LogoDialog::OnChangeEdit1() 
{
	 nIndex = m_listBox.GetCurSel ();

    
	
}

void LogoDialog::resetInit()
{
	nIndex=index;
	  
    m_editString=CmyLogoList[currentLogo]->GetLogoString(); 


	m_editbox.SetWindowText(m_editString);						// the text string of the logo
	
													

	m_listBox.SetCurSel(index);									// highlight current font selected

	CString tester;	

	CmyLogoList[currentLogo]->ListIndex = m_listBox.GetCurSel();
	
	//index= m_listBox.GetCurSel();
	
	m_listBox.GetText(CmyLogoList[currentLogo]->ListIndex,tester);

	GetFontFile(tester,fontDisplayName,fontFileName);
	

	m_scale.SetRange(0,50);
	m_scale.SetPos(CmyLogoList[currentLogo]->scale *10);
	m_red.SetRange(0,100);										// set min-max range of colour variations
	m_red.SetPos(CmyLogoList[currentLogo]->logoOutlineColour.r * 100);	// set red value
	m_green.SetRange(0,100);
	m_green.SetPos(CmyLogoList[currentLogo]->logoOutlineColour.g*100);	// set green outline value
	m_blue.SetRange(0,100);
	m_blue.SetPos(CmyLogoList[currentLogo]->logoOutlineColour.b*100);		// set blue outline value
	m_alpha.SetRange(0,100);
	m_alpha.SetPos(CmyLogoList[currentLogo]->logoOutlineColour.a*100);	// set alpha outline value

	m_redFill.SetRange(0,100);
	m_redFill.SetPos(CmyLogoList[currentLogo]->logoFillColour.r * 100);	// set red fill value
	m_greenFill.SetRange(0,100);
	m_greenFill.SetPos(CmyLogoList[currentLogo]->logoFillColour.g*100);	// set green fill value
	m_blueFill.SetRange(0,100);
	m_blueFill.SetPos(CmyLogoList[currentLogo]->logoFillColour.b*100);	// set blue fill value
	m_alphaFill.SetRange(0,100);
	m_alphaFill.SetPos(CmyLogoList[currentLogo]->logoFillColour.a*100);	// set alpha fill value

	
	m_height.SetRange(0,20);
	m_height.SetPos((int)CmyLogoList[currentLogo]->height);				//set height

	m_OutlineWidth.SetRange(0,10);
	m_OutlineWidth.SetPos(CmyLogoList[currentLogo]->outlineWidth);		//set outline width

}

BOOL LogoDialog::OnInitDialog() 
{
	CDialog::OnInitDialog();

	//nIndex=index;
	  
    m_editString=CmyLogoList[currentLogo]->GetLogoString(); 


	m_editbox.SetWindowText(m_editString);						// the text string of the logo
	
	FillListBox();												// fill list box with fonts installed

	//m_listBox.SetCurSel(index);									// highlight current font selected
	
	m_listBox.SetCurSel(CmyLogoList[currentLogo]->ListIndex);	

	CString tester;	
	
	index= m_listBox.GetCurSel();

	CmyLogoList[currentLogo]->ListIndex=m_listBox.GetCurSel(); 
	
	m_listBox.GetText(index,tester);

	GetFontFile(tester,fontDisplayName,fontFileName);
	

	m_scale.SetRange(0,50);
	m_scale.SetPos(CmyLogoList[currentLogo]->scale *10);
	m_red.SetRange(0,100);										// set min-max range of colour variations
	m_red.SetPos(CmyLogoList[currentLogo]->logoOutlineColour.r * 100);	// set red value
	m_green.SetRange(0,100);
	m_green.SetPos(CmyLogoList[currentLogo]->logoOutlineColour.g*100);	// set green outline value
	m_blue.SetRange(0,100);
	m_blue.SetPos(CmyLogoList[currentLogo]->logoOutlineColour.b*100);		// set blue outline value
	m_alpha.SetRange(0,100);
	m_alpha.SetPos(CmyLogoList[currentLogo]->logoOutlineColour.a*100);	// set alpha outline value

	m_redFill.SetRange(0,100);
	m_redFill.SetPos(CmyLogoList[currentLogo]->logoFillColour.r * 100);	// set red fill value
	m_greenFill.SetRange(0,100);
	m_greenFill.SetPos(CmyLogoList[currentLogo]->logoFillColour.g*100);	// set green fill value
	m_blueFill.SetRange(0,100);
	m_blueFill.SetPos(CmyLogoList[currentLogo]->logoFillColour.b*100);	// set blue fill value
	m_alphaFill.SetRange(0,100);
	m_alphaFill.SetPos(CmyLogoList[currentLogo]->logoFillColour.a*100);	// set alpha fill value

	
	m_height.SetRange(0,20);
	m_height.SetPos((int)CmyLogoList[currentLogo]->height);				//set height

	m_OutlineWidth.SetRange(0,10);
	m_OutlineWidth.SetPos(CmyLogoList[currentLogo]->outlineWidth);		//set outline width
	
	
	return TRUE;  
}

void LogoDialog::FillListBox()
{
	m_listBox.ResetContent ();

    CClientDC dc (this);
    ::EnumFontFamilies ((HDC) dc, NULL, (FONTENUMPROC) EnumFontFamProc,
        (LPARAM) this);
}

int CALLBACK LogoDialog::EnumFontFamProc (ENUMLOGFONT* lpelf,
    NEWTEXTMETRIC* lpntm, int nFontType, LPARAM lParam)
{
    LogoDialog* pWnd = (LogoDialog*) lParam;

    if (nFontType & TRUETYPE_FONTTYPE)
    pWnd->m_listBox.AddString (lpelf->elfLogFont.lfFaceName);
	
    return 1;
}


void LogoDialog::OnOK() 
{
	// TODO: Add extra validation here
	m_editbox.GetWindowText(m_editString);
	
	CmyLogoList[currentLogo]->SetLogoString(m_editString);

	CmyLogoList[currentLogo]->logoOutlineColour.r = (float)m_red.GetPos()/100;
	CmyLogoList[currentLogo]->logoOutlineColour.g = (float)m_green.GetPos()/100;
	CmyLogoList[currentLogo]->logoOutlineColour.b = (float)m_blue.GetPos()/100;
	CmyLogoList[currentLogo]->logoOutlineColour.a = (float)m_alpha.GetPos()/100;

	CmyLogoList[currentLogo]->logoFillColour.r = (float)m_redFill.GetPos()/100;
	CmyLogoList[currentLogo]->logoFillColour.g = (float)m_greenFill.GetPos()/100;
	CmyLogoList[currentLogo]->logoFillColour.b = (float)m_blueFill.GetPos()/100;
	CmyLogoList[currentLogo]->logoFillColour.a = (float)m_alphaFill.GetPos()/100;

	CmyLogoList[currentLogo]->scale = (float)m_scale.GetPos()/10;

	CmyLogoList[currentLogo]->height = (float)m_height.GetPos();

	CmyLogoList[currentLogo]->outlineWidth = (float)m_OutlineWidth.GetPos();
	
	CmyLogoList[currentLogo]->fontFileName=fontFileName;
	

	CDialog::OnOK();
}




void LogoDialog::OnControl1() 
{
	// TODO: Add your control notification handler code here
	
}

BOOL LogoDialog::OnNotify(WPARAM wParam, LPARAM lParam, LRESULT* pResult) 
{
	// TODO: Add your specialized code here and/or call the base class
	
	return CDialog::OnNotify(wParam, lParam, pResult);
}

void LogoDialog::OnRadio1() 
{
	 currentLogo=0;
	
	resetInit();
	
}

void LogoDialog::OnRadio2() 
{
	currentLogo=1;
	
	resetInit();
		
}

void LogoDialog::OnRadio4() 
{
	if(CmyLogoList.size()<=3) currentLogo=2;
	
	resetInit();
	
}

void LogoDialog::OnRadio5() 
{
	// TODO: Add your control notification handler code here
	
}

void LogoDialog::OnRadio6() 
{
	// TODO: Add your control notification handler code here
	
}

void LogoDialog::OnRadio7() 
{
	// TODO: Add your control notification handler code here
	
}

void LogoDialog::OnRadio8() 
{
	// TODO: Add your control notification handler code here
	
}

void LogoDialog::OnRadio9() 
{
	// TODO: Add your control notification handler code here
	
}

void LogoDialog::OnRadio10() 
{
	// TODO: Add your control notification handler code here
	
}
