// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "type.h"

#include "MainFrm.h"
#include "LogoDialog.h"
#include "myTextDialog.h"
#include "myLogoSpin.h"


#include"myLogo.h"
#include"MyText.h"

#include"aviPlayer.h"
#include "Win32_Frametimer.h"

#include <vector>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

using namespace std;

extern vector<CmyText*> CmyTextList;
extern vector<CmyLogo*> CmyLogoList;

extern int avi;

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_WM_TIMER()
	ON_COMMAND(ID_LOGO_EDITLOGO, OnLogoEditlogo)
	ON_COMMAND(ID_LOGO_CREATELOGO, OnLogoCreatelogo)
	ON_COMMAND(ID_TEXTFILE_LOADTEXTFILE, OnLoadtextfile)
	ON_COMMAND(ID_TEXTFILE_EDITTEXTOUTPUT, OnEdittextoutput)
	ON_COMMAND(ID_BACKGROUND_LOADAVIFILE, OnBackgroundLoadavifile)
	ON_COMMAND(ID_APP_EXIT, OnAppExit)
	ON_COMMAND(ID_LOGO_SPINCONTROL, OnLogoSpincontrol)
	ON_COMMAND(ID_S, OnS)
	ON_COMMAND(ID_E, OnE)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
}

CMainFrame::~CMainFrame()
{
	AviCleanup();
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers


void CMainFrame::OnTimer(UINT nIDEvent) 
{
	
	
	CFrameWnd::OnTimer(nIDEvent);
}


void CMainFrame::OnLogoCreatelogo() 
{
	// TODO: Add your command handler code here
	initLogo();
	OnLogoEditlogo();
	
}

void CMainFrame::OnLogoEditlogo() 
{
	if(CmyLogoList.size() !=0)
	{
		LogoDialog *pDialog = new LogoDialog();

		if(pDialog->DoModal() == IDOK)
		{
			

		  // affect changes that the dialog box made 

		}
		else
		{

		  // don't do anything.... 

		}

		delete pDialog;
	}
	else
	{
		MessageBox("No logo created yet","Logo",  MB_OK);
	}

 }


void CMainFrame::OnLoadtextfile() 
{
	initText();
	OnEdittextoutput();
	
}

void CMainFrame::OnEdittextoutput() 
{
	if(CmyTextList.size()!=0)
	{
	
		myTextDialog *pDialog = new myTextDialog();

		if(pDialog->DoModal() == IDOK)
		{
			
		CmyTextList[0]->isActivated=1;
		  // affect changes that the dialog box made 

		}
		else
		{

		  // don't do anything.... 

		}

		delete pDialog;
	}
	else
	{
		MessageBox("No text created yet","Text",  MB_OK);
	}
	
}

void CMainFrame::OnBackgroundLoadavifile() 
{

	//avi = AviTextureOpen("kgb.avi",512);

	TCHAR szFilters[] =
	_T("Avi files (*.avi)|*.avi|All files (*.*)|*.*||");
	
	CFileDialog dlg(TRUE,("avi"),_T("*.avi"),OFN_HIDEREADONLY,szFilters);

	if (dlg.DoModal() ==IDOK)
	{

		CString file = dlg.GetPathName();

		MessageBox(file,NULL,MB_OK);
			
		LPTSTR filename = new TCHAR[file.GetLength()+1];
		_tcscpy(filename, file);

		avi = AviTextureOpen(filename,512);
	}

	else
	{
	
	}

	delete dlg;

	
}

void CMainFrame::OnAppExit() 
{
	AviCleanup();
	
}

void CMainFrame::OnLogoSpincontrol() 
{
	if(CmyLogoList.size()!=0)
	{
		myLogoSpin *pDialog = new myLogoSpin();

		if(pDialog->DoModal() == IDOK)
		{
			
		

		}
		else
		{

		  // don't do anything.... 

		}

		delete pDialog;
	}
	else
	{
		MessageBox("No logo created yet","Logo",  MB_OK);
	}
	
}

void CMainFrame::OnS() 
{
	OnLogoSpincontrol();
	
}

void CMainFrame::OnE() 
{
	OnLogoEditlogo();
	
}
