//-------------------------------------------------------------------------------
//
//		Keith Burgess 2004 - source file for pixmap text output
//
//
//-------------------------------------------------------------------------------

#include"stdafx.h"
#include "MyText.h"

#include <vector>
#include "UTIL.H"

using namespace std;
using namespace GraphicsLib;

vector<CmyText*> CmyTextList;		//global list of txt files to display

int g_time=0;
int currentText;					//global variable for current selected list

CmyText::CmyText()
{

	isActivated = 0;
	
	fontPath=("C:\/WINDOWS/Fonts/");
	fontFileName=("arial.ttf");
	fontFile = fontPath + fontFileName;

	fullText = ("hello");

	yPos = 450;
	xPos=50;

	textColour.r= 1.0f;
	textColour.g= 1.0f;
	textColour.b= 1.0f;
	textColour.a= 1.0f;

	pointSize =20;

	alignmentMode=1;
	currentLine=0;

	PrintMethod =0;

	displayTime=25*5;	// 5 secs

	fadeTime= 25;
	fadeTextAlpha=0.1;
	fadeVal=1;
	fadeSpeed=0.04;

	fin=fout=1;

	transX=0;
	transSpeed=10;

}


CmyText::~CmyText()
{
}

void CmyText::CreateText()
{

	fontFile = fontPath + fontFileName;

	glPushMatrix();

	LPTSTR fontChar = new TCHAR[fontFile.GetLength()+1];
	_tcscpy(fontChar, fontFile);

	 FTFace face;
       if( ! face.open(fontChar) );// MessageBox(NULL,"unable to create pixmap face",NULL,MB_OK);
         
       //GLTTPixmapFont font(&face);

	   pixFont.setFace(&face);
        
       if( ! pixFont.create(pointSize) );// MessageBox(NULL,"unable to create pixmapped font",NULL,MB_OK);
         
       // ... OpenGL initialization commands...
       

	   choosePrintMethod();

       //pixFont.output(0, yPos , lpsz );
	   pixFont.destroy();
	
	 glPopMatrix();
}

void CmyText::printAllLines()
{
	int lineOffset=0;
	//glRasterPos2f(20,0);
	glLoadIdentity();

	for(int i=0;i<myStringList.size();i++)
	{
		CString theLine= *myStringList[i];

		LPTSTR lpsz = new TCHAR[theLine.GetLength()+1];
		_tcscpy(lpsz, theLine);

		glColor4f(textColour.r,textColour.g,textColour.b, textColour.a);

		pixFont.output(xPos, yPos+lineOffset, lpsz );

		lineOffset-=pointSize;
	}

	
}
void CmyText::printSingleLines()
{
	glLoadIdentity();

	
		CString theLine= *myStringList[currentLine];

		LPTSTR lpsz = new TCHAR[theLine.GetLength()+1];
		_tcscpy(lpsz, theLine);
		
		if(	alignmentMode == 2|
			alignmentMode == 5|
			alignmentMode == 8) centralize();

		if(	alignmentMode == 3|
			alignmentMode == 6|
			alignmentMode == 9) alignRight();

		
		glColor4f(textColour.r,textColour.g,textColour.b, fadeTextAlpha);

		if( g_time + fadeTime >= displayTime) fadeOut(); 

		pixFont.output(xPos, yPos, lpsz );
			
		if(displayTime < g_time)
		{
			
			advanceLine();
			
		}

		if( g_time <= fadeTime)	fadeIn();
}

void CmyText::printLineScan()
{


	LPTSTR lpsz = new TCHAR[fullText.GetLength()+1];
	_tcscpy(lpsz, fullText);

	glColor4f(textColour.r,textColour.g,textColour.b, textColour.a);

	pixFont.output(750-transX, yPos, lpsz );

	updateTransX();

}

void CmyText::updateTransX()
{
	LPTSTR lpsz = new TCHAR[fullText.GetLength()+1];
	_tcscpy(lpsz, fullText);

	if(transX > 720 + pixFont.getWidth(lpsz))transX=0;

	else transX+=transSpeed;
}

void CmyText::fadeOut()
{
	fadeTextAlpha =   lerp(0,textColour.a,fadeVal);
	fadeVal -= fadeSpeed;
	if (fadeVal<0)fadeVal=0;
}

void CmyText::fadeIn()
{
	fadeTextAlpha =   lerp(0,textColour.a,fadeVal);
	fadeVal += fadeSpeed;
	if (fadeVal>textColour.a)fadeVal=textColour.a;
}


void CmyText::choosePrintMethod()
{
	if(PrintMethod==0) printAllLines();
	if(PrintMethod==1) printSingleLines();
	if(PrintMethod==2) printLineScan();


}

void CmyText::advanceLine()
{
if (currentLine == myStringList.size()-1)
		{
			currentLine=0;
			
		}

	else 
		{
			currentLine++;
		}
	g_time=0;
	

}

void CmyText::centralize()
{

	CString theLine= *myStringList[currentLine];

	LPTSTR lpsz = new TCHAR[theLine.GetLength()+1];
	_tcscpy(lpsz, theLine);

	xPos= (720 - pixFont.getWidth(lpsz) )/2;
}

void CmyText::alignRight()
{
	CString theLine= *myStringList[currentLine];

	LPTSTR lpsz = new TCHAR[theLine.GetLength()+1];
	_tcscpy(lpsz, theLine);

	xPos= (720-50) - pixFont.getWidth(lpsz) ;

}

void initText()
{
	CmyText *text =new  CmyText;
	  CmyTextList.push_back(text);
}



