//-------------------------------------------------------------------------------
//
//		Keith Burgess 2004 - header file for pixmap text output
//
//
//-------------------------------------------------------------------------------
#ifndef __MYTEXT_H__
#define __MYTEXT_H__

#include "colour.h"

#include "gltt-source/FTFace.h"
#include "gltt-source/GLTTPixmapFont.h"
#include <vector>

#include<vector>



class CmyText
{
public:

	GLTTPixmapFont pixFont;
	
	CString fontPath;
	CString fontFileName;
	CString fontFile;

	int isActivated;

	CString fullText;

	std::vector<CString*> textLineList;

	int yPos;							//y position to draw glDrawPixels.
	int xPos;							//x position to draw pixels.

	Colour textColour;					//user set colour value
	float fadeTextAlpha;				//alpha value after fade
	float fadeVal;

	int pointSize;						//size in pixels to draw type.

	std::vector<CString*> myStringList;	//global string list for line output.

	int alignmentMode;					//TL=1,TC=2,TR=3,CL=4,CENTRE=5 etc;
	int currentLine;					//current line to print 
	int displayTime;					// amount of time to display line of text;
	int PrintMethod;					// sets full page, one line at a time etc.

	int fadeTime;					// amount of time that a fade takes place.
	float fadePos;						// current position along fade.
	float fadeSpeed;				//

	int transX;							//amount to displace rasterPos;
	int transSpeed;						//speed at which to increase transX

	int fin;						//flag to specifie whether fade in On;
	int fout;						//flag to specifie whether fade in Out;


	CmyText();
	~CmyText();

	void CreateText();
	void printAllLines();	// output in all lines format;
	void printSingleLines();
	void printLineScan();
	void updateTransX();
	void choosePrintMethod();
	void centralize();
	void alignRight();
	void fadeOut();
	void fadeIn();

	void advanceLine();
	

};

void initText();			// dynamically create Text object and add to list


#endif