#include "stdafx.h"
#include "Point3.h"           
using namespace std;
using namespace GraphicsLib; 
bool Point3 :: operator==(const Point3& rhs)
	{
	if(x==rhs.x && y==rhs.y && z==rhs.z)
	   return true;
    else return false;
	}
bool Point3 :: operator!=(const Point3& rhs)
	{
	if(x!=rhs.x && y!=rhs.y && z!=rhs.z)
	   return true;
    else return false;
	}

bool Point3 :: operator>(const Point3& rhs)
	{
	if(x>rhs.x && y>rhs.y && z>rhs.z)
	   return true;
    else return false;
	}
bool Point3 :: operator>=(const Point3& rhs)
	{
	if(x>=rhs.x && y>=rhs.y && z>=rhs.z)
	   return true;
    else return false;
	}
bool Point3 :: operator<(const Point3& rhs)
	{
	if(x<rhs.x && y<rhs.y && z<rhs.z)
	   return true;
    else return false;
	}
bool Point3 :: operator<=(const Point3& rhs)
	{
	if(x<=rhs.x && y<=rhs.y && z<=rhs.z)
	   return true;
    else return false;
	}


Point3 Point3 :: operator+(const Point3& rhs)
	{
	 Point3 ret;
		ret.x=x+rhs.x; ret.y=y+rhs.y; ret.z=z+rhs.z; 
	   return ret;
	}

// Point3 Point3 :: operator-(Point3& v)
// {
//   Point3 ret;
//   ret.x=x-rhs.x; ret.y=y-rhs.y; ret.z=z-rhs.z; 
//   return ret;
//  }

void Point3::operator+=(const Point3 &rhs)
{
x+=rhs.x; y+=rhs.y; z+=rhs.z;
}
void Point3::operator+=(const Vector &rhs)
{
x+=rhs.x; y+=rhs.y; z+=rhs.z;
}

void Point3::operator-=(const Point3 &rhs)
{
x-=rhs.x; y-=rhs.y; z-=rhs.z;
}
void Point3::operator-=(const Vector &rhs)
{
x-=rhs.x; y-=rhs.y; z-=rhs.z;
}

Vector Point3 :: operator-(const Point3& rhs)
{
Vector ret;
  ret.x=x-rhs.x; ret.y=y-rhs.y; ret.z=z-rhs.z; ret.w=0.0;
return ret;
}


Point3 Point3 :: operator-(const Vector& rhs)
{
	Point3 ret;
	   ret.x=x-rhs.x; ret.y=y-rhs.y; ret.z=z-rhs.z; 
	   return ret;
}

Point3 Point3 :: operator+(const Vector& rhs)
{
	Point3 ret; 
	   ret.x=x+rhs.x; ret.y=y+rhs.y; ret.z=z+rhs.z; 
	   return ret;
}
Point3 Point3::operator*(GLfloat rhs)
{
Point3 ret;
ret.x=x*rhs; ret.y=y*rhs; ret.z=z*rhs;
return ret;
}

void Point3::operator*=(GLfloat rhs)
{
x*=rhs; y*=rhs; z*=rhs; 
}
Point3 Point3::operator*(const Vector &rhs)
{
Point3 ret;
ret.x=x*rhs.x; ret.y=y*rhs.y; ret.z=z*rhs.z;
return ret;
}
Point3 Point3::operator*(const Point3 &rhs)
{
Point3 ret;
ret.x=x*rhs.x; ret.y=y*rhs.y; ret.z=z*rhs.z;
return ret;
}


Point3 Point3 :: operator/(float rhs)
{
	Point3 ret=*this;
	   ret.x/=rhs; ret.y/=rhs; ret.z/=rhs; 
	   return ret;
}

void Point3 :: Vertex(void)
{
glVertex3f(x,y,z);

}

void Point3 :: Translate(void)
{
glTranslatef(x,y,z);
}

void Point3 :: Normal(void)
{
glNormal3f(x,y,z);
}


ostream& GraphicsLib::operator<<(ostream& output, const Point3 & s)
  {
    return output<<"["<<s.x<<","<<s.y<<","<<s.z<<"]";
  }

istream& GraphicsLib::operator>>(std::istream& input, Point3 &s)
{
return input >> s.x >> s.y >> s.z;

}


void Point3::normalize(void)
	{
	GLfloat len=(GLfloat)sqrt(x*x+y*y+z*z);
	if (len==0.0f)
		return;
	x/=len; y/=len; z/=len;
	}
    
Point3 Point3::operator*(const Matrix &rhs)
{
  Point3 a;
  float *f=(float *)&rhs;
  a.x = x*f[0] + y*f[4] + z*f[8] +f[3];
  a.y = x*f[1] + y*f[5] + z*f[9] +f[7]; 
  a.z = x*f[2] + y*f[6] + z*f[10] +f[11];
  return a;
}


    
    
