//-------------------------------------------------------------------------------
//
//		Keith Burgess 2004 - source file for pixmap text output
//
//
//-------------------------------------------------------------------------------


#include"stdafx.h"

#include"myLogo.h"

#include "gltt-source/FTFace.h"
#include "gltt-source/FTFont.h"
#include "gltt-source/FTInstance.h"
#include "gltt-source/FTGlyphVectorizer.h"
#include "gltt-source/GLTTFont.h"
#include "gltt-source/freetype/freetype.h"

#include "iostream"
#include <vector>

#ifdef WIN32
#include <windows.h>
#endif

#ifdef LOCAL_GL_HEADER
  #include "local_gl.h"
#else
  #include <GL/gl.h>
#endif

using namespace std;

vector<CmyLogo*> CmyLogoList;

int currentLogo=0;				// global variable for selected list item;


CmyLogo::CmyLogo()
{
	stringName=("LOGO") ;
	fontPath=("C:\/WINDOWS/Fonts/");
	fontFileName=("arial.ttf");
	fontFile = fontPath + fontFileName;
	logoOutlineColour.r=0.5f;		//logo outline colour
	logoOutlineColour.g=0.7f;
	logoOutlineColour.b=0.9f;
	logoOutlineColour.a=0.8f;

	logoFillColour.r=1.0f;			//logo fill colour
	logoFillColour.g=0.7f;
	logoFillColour.b=0.2f;
	logoFillColour.a=0.8f;

	scale =1;

	spinSpeedX=0;						//amount of logo rotation increment
	spinSpeedY=0;
	spinSpeedZ=0;

	spinDegX=0;						//amount of logo rotation degrees
	spinDegY=0;
	spinDegZ=0;

	outlineWidth=3;

	height = 0.0;

	ListIndex = 0;

	PivotX=PivotY=PivotZ=0;

}

CmyLogo::~CmyLogo()
{
}

CString CmyLogo::GetLogoString()
{
	return stringName;
}

void CmyLogo::SetLogoString(CString str)
{
	stringName=str;	
}

void CmyLogo::CreateLogo()
{
	FTFace face;
	
	
	fontFile = fontPath + fontFileName;
	
	LPTSTR fontChar = new TCHAR[fontFile.GetLength()+1];
	_tcscpy(fontChar, fontFile);

	if(!face.open(fontChar)) MessageBox(NULL,fontFile,NULL,MB_OK);
	
	LPTSTR lpsz = new TCHAR[stringName.GetLength()+1];
	_tcscpy(lpsz, stringName);

	int point_size= 90;

	

	outline.setFace(&face);
	fontFill.setFace(&face);

    if(!outline.create(point_size));// MessageBox(NULL,"unable to create outline font",NULL,MB_OK);
	if(!fontFill.create(point_size));// MessageBox(NULL,"unable to create fill font",NULL,MB_OK);


	glLineWidth(outlineWidth);

	glColor4f(	logoOutlineColour.r,
				logoOutlineColour.g,
				logoOutlineColour.b,
				logoOutlineColour.a);


    outline.output(lpsz);
	

	glLineWidth(1);

  	glColor4f(	logoFillColour.r,
				logoFillColour.g,
				logoFillColour.b,
				logoFillColour.a);
	
	
	
	fontFill.output(lpsz);
	
	outline.destroy();
	fontFill.destroy();
	
	UpdateSpin();
}


GLTTboolean CmyLogo::transformPoints( int i )
{

  return GLTT_TRUE;
}

 void initLogo()
{CmyLogo *logo =new  CmyLogo;
	  CmyLogoList.push_back(logo);
	  
}

void CmyLogo::UpdateSpin()
 {
	if(spinDegX>360) spinDegX=spinDegX-360;
	spinDegX+=spinSpeedX;

	if(spinDegY>360) spinDegY-=360;
	spinDegY+=spinSpeedY;

	if(spinDegZ>360) spinDegZ-=360;
	spinDegZ+=spinSpeedZ;

 }




