// myTextDialog.cpp : implementation file
//

#include "stdafx.h"
#include "type.h"
#include "myTextDialog.h"
#include "FadeControlDialog.h"
#include "MyText.h"
#include <algorithm>
#include <vector>

#include "fontFind/GetFontFile.h"		//utility for finding font filename

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

using namespace std;

int index2=0;	//KGB added for control of listbox font selection

CString g_texfileName=("");
CString fontFileName2;
CString fontDisplayName2;

CString pointsize;

extern vector <CmyText*> CmyTextList;

/////////////////////////////////////////////////////////////////////////////
// myTextDialog dialog


myTextDialog::myTextDialog(CWnd* pParent /*=NULL*/)
	: CDialog(myTextDialog::IDD, pParent)
{

	//m_textFileName = g_texfileName;
	//{{AFX_DATA_INIT(myTextDialog)
	m_pointSizeEdit = 0;
	//}}AFX_DATA_INIT
}


void myTextDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(myTextDialog)
	DDX_Control(pDX, IDC_POINTSIZE_SLIDER, m_pss);
	DDX_Control(pDX, IDC_TXTSLIDER_ALPHA2, m_alpha);
	DDX_Control(pDX, IDC_TXTSLIDER_BLUE3, m_blue);
	DDX_Control(pDX, IDC_TXTSLIDER_GREEN2, m_green);
	DDX_Control(pDX, IDC_TXTSLIDER_RED2, m_red);
	DDX_Control(pDX, IDC_SLIDER1, m_panSpeedSldr);
	DDX_Control(pDX, IDC_LIST1, m_listBox);
	DDX_Control(pDX, IDC_EDIT1, m_textFileName);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(myTextDialog, CDialog)
	//{{AFX_MSG_MAP(myTextDialog)
	ON_BN_CLICKED(IDC_LOAD_TEXT, OnLoadText)
	ON_EN_CHANGE(IDC_EDIT1, OnChangeEdit1)
	ON_BN_CLICKED(IDC_COLOUR, OnColour)
	ON_LBN_SELCHANGE(IDC_LIST1, OnSelchangeList1)
	ON_BN_CLICKED(IDC_RADIO_PAL, OnRadioPal)
	ON_BN_CLICKED(IDC_RADIO_PSL, OnRadioPsl)
	ON_BN_CLICKED(IDC_RADIO_SLP, OnRadioSlp)
	ON_BN_CLICKED(IDC_RADIO_TL, OnRadioTl)
	ON_BN_CLICKED(IDC_RADIO_TC, OnRadioTc)
	ON_BN_CLICKED(IDC_RADIO_TR, OnRadioTr)
	ON_BN_CLICKED(IDC_RADIO_CL, OnRadioCl)
	ON_BN_CLICKED(IDC_RADIO_C, OnRadioC)
	ON_BN_CLICKED(IDC_RADIO_CR, OnRadioCr)
	ON_BN_CLICKED(IDC_RADIO_BL, OnRadioBl)
	ON_BN_CLICKED(IDC_RADIO_BC, OnRadioBc)
	ON_BN_CLICKED(IDC_RADIO_BR, OnRadioBr)
	ON_BN_CLICKED(IDC_BUTTON_FADECONTROL, OnButtonFadecontrol)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// myTextDialog message handlers

void myTextDialog::OnLoadText() 
{
	TCHAR szFilters[] =
	_T("Text files (*.txt)|*.txt|All files (*.*)|*.*||");

	CFileDialog dlg(TRUE,("txt"),_T("*.txt"),OFN_HIDEREADONLY,szFilters);

	if (dlg.DoModal() ==IDOK)
	{
		m_textFileName.SetWindowText(dlg.GetFileName());

		CString string;

		g_texfileName = dlg.GetPathName();

		CStdioFile file (dlg.GetPathName(), CFile::modeRead);

		CmyTextList[0]->fullText=("");

		int lineCount=0;							//used to count lines;

		while(file.ReadString(string))
		{
					
			CmyTextList[0]->fullText+=string;		//add all lines to a string called fullText

			CString *lineString = new CString;
		
			CmyTextList[0]->myStringList.push_back(lineString);

			CmyTextList[0]->myStringList[lineCount]->Insert(0,string);

			lineCount++;
			
		}
		
	
	}

	else
	{

	}

	delete dlg;
	
}

void myTextDialog::OnChangeEdit1() 
{
	
	
	
}

void myTextDialog::OnColour() 
{
	CColorDialog *colourDialog();

	
}

void myTextDialog::OnSelchangeList1() 
{
	CString tester;	
	
	index2 = m_listBox.GetCurSel();
	
	m_listBox.GetText(index2,tester);

	GetFontFile(tester,fontDisplayName2,fontFileName2);	
	
}

BOOL myTextDialog::OnInitDialog() 
{
	CDialog::OnInitDialog();

	//SetUpCheckState();

	m_panSpeedSldr.SetRange(0,30);
	m_panSpeedSldr.SetPos(CmyTextList[0]->transSpeed);
	m_pss.SetRange(0,50);
	m_pss.SetPos(CmyTextList[0]->pointSize);


	m_red.SetRange(0,100);										// set min-max range of colour variations
	m_red.SetPos(CmyTextList[0]->textColour.r * 100);	// set red value
	m_green.SetRange(0,100);
	m_green.SetPos(CmyTextList[0]->textColour.g*100);	// set green outline value
	m_blue.SetRange(0,100);
	m_blue.SetPos(CmyTextList[0]->textColour.b *100);		// set blue outline value
	m_alpha.SetRange(0,100);
	m_alpha.SetPos(CmyTextList[0]->textColour.a *100);	// set alpha outline value


		
	nIndex=index2;						//global index for font list currently selected

	FillListBox();						// fill list box with fonts

	m_listBox.SetCurSel(index2);		//select the currently selected font

	CString tester;	
	
	index2= m_listBox.GetCurSel();
	
	m_listBox.GetText(index2,tester);


	

	return TRUE;  
}


void myTextDialog::FillListBox()
{
	m_listBox.ResetContent ();

    CClientDC dc (this);
    ::EnumFontFamilies ((HDC) dc, NULL, (FONTENUMPROC) EnumFontFamProc,
        (LPARAM) this);
}


int CALLBACK myTextDialog::EnumFontFamProc (ENUMLOGFONT* lpelf,
    NEWTEXTMETRIC* lpntm, int nFontType, LPARAM lParam)
{
    myTextDialog* pWnd = (myTextDialog*) lParam;

    if (nFontType & TRUETYPE_FONTTYPE)
    pWnd->m_listBox.AddString (lpelf->elfLogFont.lfFaceName);
	
    return 1;
}



void myTextDialog::OnOK() 
{

	CmyTextList[0]->fontFileName=fontFileName2;

	CmyTextList[0]->textColour.r = (float)m_red.GetPos()/100;
	CmyTextList[0]->textColour.g = (float)m_green.GetPos()/100;
	CmyTextList[0]->textColour.b = (float)m_blue.GetPos()/100;
	CmyTextList[0]->textColour.a = (float)m_alpha.GetPos()/100;

	CmyTextList[0]->transSpeed = (float)m_panSpeedSldr.GetPos();

	CmyTextList[0]->pointSize = m_pss.GetPos();



	//CmyTextList[0]->pointSize = pointsize

	
	CDialog::OnOK();
}

void myTextDialog::SetUpCheckState()
{
//	m_radioPAL.SetCheck(BST_CHECKED);
}



void myTextDialog::OnRadioPal() 
{
	CmyTextList[0]->PrintMethod=0;
	
}

void myTextDialog::OnRadioPsl() 
{
	CmyTextList[0]->PrintMethod=1;
	
}

void myTextDialog::OnRadioSlp() 
{
	CmyTextList[0]->yPos = 80;
	CmyTextList[0]->PrintMethod=2;
	
}

void myTextDialog::OnRadioTl() 
{
	CmyTextList[0]->alignmentMode=1;
	CmyTextList[0]->xPos = 50;
	CmyTextList[0]->yPos = 450;
	
	
}

void myTextDialog::OnRadioTc() 
{
	CmyTextList[0]->alignmentMode=2;
	CmyTextList[0]->yPos = 450;
	
}

void myTextDialog::OnRadioTr() 
{
	CmyTextList[0]->alignmentMode=3;
	CmyTextList[0]->yPos = 450;
	
}

void myTextDialog::OnRadioCl() 
{
	CmyTextList[0]->alignmentMode=4;
	CmyTextList[0]->xPos = 50;
	CmyTextList[0]->yPos = 275;
	
}

void myTextDialog::OnRadioC() 
{
	CmyTextList[0]->alignmentMode=5;
	CmyTextList[0]->yPos = 275;
	
}

void myTextDialog::OnRadioCr() 
{
	CmyTextList[0]->alignmentMode=6;
	CmyTextList[0]->yPos = 275;
	
}

void myTextDialog::OnRadioBl() 
{
	CmyTextList[0]->alignmentMode=7;
	CmyTextList[0]->yPos = 80;
	CmyTextList[0]->xPos = 50;
	
}

void myTextDialog::OnRadioBc() 
{
	CmyTextList[0]->alignmentMode=8;
	CmyTextList[0]->yPos = 80;
	
}

void myTextDialog::OnRadioBr() 
{
	CmyTextList[0]->alignmentMode=9;
	CmyTextList[0]->yPos = 80;
	
}


void myTextDialog::OnButtonFadecontrol() 
{
	FadeControlDialog *dlg = new FadeControlDialog();

		if(dlg->DoModal() == IDOK)
		{
		  

		}
		else
		{
		  // don't do anything.... 

		}

		delete dlg;

	
}
