// typeView.cpp : implementation of the CTypeView class
//

#include "stdafx.h"
#include "type.h"

#include "typeDoc.h"
#include "typeView.h"

#include "LogoDialog.h"

#include "gltt-source/freetype/freetype.h"
#include "gltt-source/GLTTOutlineFont.h"
#include "gltt-source/GLTTFont.h"
#include "gltt-source/FTFace.h"
#include "gltt-source/GLTTPixmapFont.h"
#include "myLogo.h"
#include "MyText.h"

#include "win32_frametimer.h"
#include "AviPlayer.h"

#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glaux.h>

#include<iostream>
#include<vector>

using namespace std;

extern vector <CmyLogo*> CmyLogoList;
extern vector <CmyText*> CmyTextList;

extern currentLogo;
extern currentText;
extern g_time;


extern int avi;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

using namespace std;

int transX=0;





/////////////////////////////////////////////////////////////////////////////
// CTypeView

IMPLEMENT_DYNCREATE(CTypeView, CView)

BEGIN_MESSAGE_MAP(CTypeView, CView)
	//{{AFX_MSG_MAP(CTypeView)
	ON_WM_SIZE()
	ON_WM_CREATE()
	ON_WM_DESTROY()
	ON_WM_LBUTTONUP()
	ON_WM_LBUTTONDOWN()
	ON_WM_RBUTTONDOWN()
	ON_WM_RBUTTONUP()
	ON_WM_MOUSEMOVE()
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTypeView construction/destruction

CTypeView::CTypeView(): 
m_bLMB(false),m_bMMB(false),m_bRMB(false),
m_fZoom(0),m_fTransX(0),m_fTransY(0),
m_fSpinX(0.001f),m_fSpinY(0.001f),m_fNear(0.1f),m_fFar(150.0f)

{
	
}

CTypeView::~CTypeView()
{
}

BOOL CTypeView::PreCreateWindow(CREATESTRUCT& cs)
{
	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CTypeView drawing

void CTypeView::OnDraw(CDC* pDC)
{
	CTypeDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	MyDrawFunc();
}

/////////////////////////////////////////////////////////////////////////////
// CTypeView diagnostics

#ifdef _DEBUG
void CTypeView::AssertValid() const
{
	CView::AssertValid();
}

void CTypeView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CTypeDoc* CTypeView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CTypeDoc)));
	return (CTypeDoc*)m_pDocument;
}

BOOL CTypeView::SetWindowPixelFormat(HDC hDC)
{ 
	PIXELFORMATDESCRIPTOR pixelDesc;

	pixelDesc.nSize = sizeof(PIXELFORMATDESCRIPTOR);
	pixelDesc.nVersion = 1;

	pixelDesc.dwFlags = PFD_DRAW_TO_WINDOW |
	PFD_DOUBLEBUFFER |
	PFD_SUPPORT_OPENGL ;

	// set these fields to get the desired pixel format
	pixelDesc.iPixelType = PFD_TYPE_RGBA;
	pixelDesc.cColorBits = 32;
	pixelDesc.cRedBits = 8;
	pixelDesc.cRedShift = 16;
	pixelDesc.cGreenBits = 8;
	pixelDesc.cGreenShift = 8;
	pixelDesc.cBlueBits = 8;
	pixelDesc.cBlueShift = 0;
	pixelDesc.cAlphaBits = 0;
	pixelDesc.cAlphaShift = 0;
	pixelDesc.cAccumBits = 64;
	pixelDesc.cAccumRedBits = 16;
	pixelDesc.cAccumGreenBits = 16;
	pixelDesc.cAccumBlueBits = 16;
	pixelDesc.cAccumAlphaBits = 0;
	pixelDesc.cDepthBits = 32;
	pixelDesc.cStencilBits = 8;
	pixelDesc.cAuxBuffers = 0;
	pixelDesc.iLayerType = PFD_MAIN_PLANE;
	pixelDesc.bReserved = 0;
	pixelDesc.dwLayerMask = 0;
	pixelDesc.dwVisibleMask = 0;
	pixelDesc.dwDamageMask = 0;

	m_OpenglPixelIndex = ChoosePixelFormat( hDC, &pixelDesc);
	if (m_OpenglPixelIndex==0) // Let's choose a default index.
	{

	  m_OpenglPixelIndex = 1;
	if (DescribePixelFormat(hDC, m_OpenglPixelIndex, sizeof(PIXELFORMATDESCRIPTOR), &pixelDesc)==0)
	{
	  return FALSE; 
	} 

	}

	if (SetPixelFormat( hDC, m_OpenglPixelIndex, &pixelDesc)==FALSE)
	{

	  return FALSE; 

	} 
	return TRUE; 
 


}

 

BOOL CTypeView::CreateOpenglContext(HDC hDC)
{

  m_hOpenglContext = wglCreateContext(hDC);
if (m_hOpenglContext == NULL) return FALSE;

if (wglMakeCurrent(hDC, m_hOpenglContext)==FALSE) return FALSE;

return TRUE;
 

}


#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CTypeView message handlers

void CTypeView::OnSize(UINT nType, int cx, int cy) 
{
	CView::OnSize(nType, cx, cy);
	
	// set up the OpenGL viewport and viewing transformations
	if (cy==0) cy=1;
	glViewport(0, (GLsizei) 0, (GLsizei) cx, (GLsizei) cy);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluPerspective(55.0, cx/cy , 0.01, 2000 );
	gluLookAt(360,288,700,360,288,0,0,1,0);
	
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();

	
}

int CTypeView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CView::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (CWnd::OnCreate(lpCreateStruct) == -1) return -1;

	
	HWND hWnd = GetSafeHwnd();
	m_hDC = ::GetDC(hWnd);

	if (SetWindowPixelFormat(m_hDC)==FALSE) return 0;

	if (CreateOpenglContext(m_hDC)==FALSE) return 0;

	// do the openGL initialisation that you want here
	glClearColor(0,0,0,0);
	glShadeModel(GL_SMOOTH);
	//glEnable(GL_DEPTH_TEST);
	//glEnable(GL_CULL_FACE);
	glEnable(GL_BLEND);
	//glEnable(GL_POINT_SMOOTH);
	glEnable(GL_LINE_SMOOTH);
	glEnable(GL_TEXTURE_2D);

	glHint(GL_POINT_SMOOTH_HINT,GL_NICEST);
	//glHint(GL_LINE_SMOOTH_HINT,GL_NICEST);

	//glBlendFunc(GL_SRC_ALPHA,GL_DST_ALPHA);


	SetTimer (1, 40, NULL);

	InitFrameTime();
	
	
	return 0;
}

void CTypeView::OnDestroy() 
{
	CView::OnDestroy();

	AviCleanup();
	
	if (wglGetCurrentContext()!=NULL) wglMakeCurrent(NULL, NULL);

	if (m_hOpenglContext!=NULL)
	{
		wglDeleteContext(m_hOpenglContext);
		m_hOpenglContext = NULL; 
	}
}

void CTypeView::MyDrawFunc()
{

	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
	
	
	
	glLoadIdentity();

	// do the maya style mouse transformations
	glTranslatef( m_fTransX , m_fTransY-0.5f , m_fZoom-20 );
	glRotatef ( m_fSpinX , 1.0f, 0.0f, 0.0f );
	glRotatef ( m_fSpinY , 0.0f, 1.0f, 0.0f );

	// draw your 3D stuff between this push/pop matrix

	//draw 720 x 576 rect

	glBegin(GL_LINE_LOOP);

		// x in red
		glColor3f(0.2f,0.2f,0.2f);
		glVertex3f(0,0,0);
		glVertex3f(720,0,0);
		glVertex3f(720,576,0);
		glVertex3f(0,576,0);

	glEnd();

	//draw centre
	glBegin(GL_LINES);
		glColor3f(0.3f,0.3f,0.3f);
		glVertex3f(0,0,0);
		glVertex3f(720,576,0);
	glEnd();

	glBegin(GL_LINES);
		
		glVertex3f(0,576,0);
		glVertex3f(720,0,0);
	glEnd();

	//glColor4f(1,1,1,0.1f);


	
	
glEnable(GL_TEXTURE_2D);
if (avi !=0)				//if there is no avi file loaded
	{
	AviTextureBind(avi);

	glBegin(GL_QUADS);
		// x in red
		glColor4f(1.0f,1.0f,1.0f,1.0f);
		glTexCoord3f(0.0f,0.0f,0.0f); glVertex3f(0,0,-5);
		glTexCoord3f(1.0f,0.0f,0.0f); glVertex3f(720,0,-5);
		glTexCoord3f(1.0f,1.0f,0.0f); glVertex3f(720,576,-5);
		glTexCoord3f(0.0f,1.0f,0.0f); glVertex3f(0,576,-5);

	glEnd();
	}
///////////////////////////////////////////////////////////////////////////////////////////////////////

glDisable(GL_TEXTURE_2D);


	glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);

//////////////////////////////////////////////////////////////////////////////////////////////////////
if(CmyTextList.size() !=0)
	{
		if(CmyTextList[0]->isActivated ==1)	CmyTextList[0]->CreateText();
	}


if(CmyLogoList.size() !=0) 
	{
	CmyLogoList[currentLogo]->CreateLogo();
	}

	
///////////////////////////////////////////////////////////////////////////////
	
	SwapBuffers(m_hDC);
	transX+=10;

	if(transX>2500) transX-=2500;

	UpdateFrameTime();
	AviUpdate( GetFrameTime() );	//update avi background file;

}



void CTypeView::OnLButtonUp(UINT nFlags, CPoint point) 
{
	m_bLMB = false;

	
	CView::OnLButtonUp(nFlags, point);
}

void CTypeView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	m_bLMB = true;
	m_iLastPosX = point.x;
	m_iLastPosY = point.y; 

	
	CView::OnLButtonDown(nFlags, point);
}

void CTypeView::OnRButtonDown(UINT nFlags, CPoint point) 
{
	m_bMMB = true;
	m_iLastPosX = point.x;
	m_iLastPosY = point.y; 
	
	CView::OnRButtonDown(nFlags, point);
}

void CTypeView::OnRButtonUp(UINT nFlags, CPoint point) 
{
	m_bMMB = false;
	
	CView::OnRButtonUp(nFlags, point);
}

void CTypeView::OnMouseMove(UINT nFlags, CPoint point) 
{
	// the amount the mouse has moved since last called
	int m_iStepX = point.x - m_iLastPosX;
	int m_iStepY = point.y - m_iLastPosY;

	// if zooming the mouse
	if( m_bLMB && m_bMMB )
	{

	  m_fZoom += 0.5f*m_iStepX; 

	}
	else
	// if rotating the mouse
	if( m_bLMB )
	{

		m_fSpinX += 0.5f*m_iStepY;
		m_fSpinY += 0.5f*m_iStepX; 

	}
	else
	// if tracking the mouse
	if( m_bMMB )
	{

		m_fTransX += 0.5f*m_iStepX;
		m_fTransY -= 0.5f*m_iStepY; 

	}

	// store the current position for next time
	m_iLastPosX = point.x;
	m_iLastPosY = point.y;


	CView::OnMouseMove(nFlags, point);
}

void CTypeView::OnTimer(UINT nIDEvent) 
{
	MyDrawFunc();
	g_time++;
	
	CView::OnTimer(nIDEvent);
}
