// typeView.h : interface of the CTypeView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_TYPEVIEW_H__7B7F1C74_9240_41E0_B7F4_BEA990D54DA1__INCLUDED_)
#define AFX_TYPEVIEW_H__7B7F1C74_9240_41E0_B7F4_BEA990D54DA1__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


class CTypeView : public CView
{
protected: // create from serialization only
	CTypeView();
	DECLARE_DYNCREATE(CTypeView)

// Attributes
public:
	CTypeDoc* GetDocument();

// Operations
public:

	bool m_bLMB, // state of left mouse button
	m_bMMB, // state of middle mouse button
	m_bRMB; // state of the right mouse button 
	int m_iLastPosX, // the last x position of the mouse
	m_iLastPosY; // the last y position of the mouse 
	float m_fZoom ,
	m_fTransX,
	m_fTransY,
	m_fSpinX,
	m_fSpinY,
	m_fNear,
	m_fFar;


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CTypeView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	//}}AFX_VIRTUAL

// Implementation
public:
	void MyDrawFunc();
	virtual ~CTypeView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
		// OpenGL Added Section --------------------------------------------
	   // function to select a supported pixel format
	BOOL SetWindowPixelFormat(HDC hDC);
	// function to create the opengl context on which to draw
	BOOL CreateOpenglContext (HDC hDC);

	int m_OpenglPixelIndex; // the pixel format chosen
	HGLRC m_hOpenglContext; // handle for the ogl context
	HDC m_hDC; // handle for the Win32 context
 

// -----------------------------------------------------------------



// Generated message map functions
protected:
	//{{AFX_MSG(CTypeView)
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnDestroy();
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnRButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnTimer(UINT nIDEvent);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in typeView.cpp
inline CTypeDoc* CTypeView::GetDocument()
   { return (CTypeDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_TYPEVIEW_H__7B7F1C74_9240_41E0_B7F4_BEA990D54DA1__INCLUDED_)
